From oracle-l-bounce@freelists.org  Thu Dec 23 13:38:25 2004
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air189.startdedicated.com (root@localhost)
 by orafaq.com (8.11.6/8.11.6) with ESMTP id iBNJcPn21317
 for <oracle-l@orafaq.com>; Thu, 23 Dec 2004 13:38:25 -0600
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air189.startdedicated.com (8.11.6/8.11.6) with ESMTP id iBNJcPa21312
 for <oracle-l@orafaq.com>; Thu, 23 Dec 2004 13:38:25 -0600
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id DC13F72C535;
 Thu, 23 Dec 2004 14:44:54 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024) with ESMTP
 id 25401-70; Thu, 23 Dec 2004 14:44:54 -0500 (EST)
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 5585C72CA8D;
 Thu, 23 Dec 2004 14:43:40 -0500 (EST)
X-MimeOLE: Produced By Microsoft Exchange V6.0.6487.1
content-class: urn:content-classes:message
MIME-Version: 1.0
Content-type: text/plain
Subject: RE: Disable/Enable scripts?
Date: Thu, 23 Dec 2004 11:40:02 -0800
Message-ID: <B5C5F99D765BB744B54FFDF35F60262109F87BA7@irvmbxw02>
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
Thread-Topic: Disable/Enable scripts?
Thread-Index: AcTpIM4dPHYQK2MrQ3e1eAQFOnq+dwABTQIwAAAuFZA=
From: "Jacques Kilchoer" <Jacques.Kilchoer@quest.com>
To: <bunjibry@gmail.com>, "Oracle-L" <oracle-l@freelists.org>
X-OriginalArrivalTime: 23 Dec 2004 19:40:03.0134 (UTC) FILETIME=[325F9DE0:01C4E927]
Content-Transfer-Encoding: 8bit
X-archive-position: 14137
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: Jacques.Kilchoer@quest.com
Precedence: normal
Reply-To: Jacques.Kilchoer@quest.com
X-list: oracle-l
X-Virus-Scanned: by amavisd-new at freelists.org

As part of my answer I forgot to say that in 9.2 you can disable a
primary key or unique constraint with the "keep index" option, e.g.
alter table disable primary key keep index ;
a lter table disable unique (col1, col2, col3) keep index ;
alter table disable constraint table_pk_constraint_name keep index ;
 
But if the enforcing index is a unique index, uniqueness of the rows
will still be enforced despite the absence of the primary key or unique
constraint.
On the other other hand, keeping the index will make re-enabling the
constraint faster and easier.
-----Original Message-----
Bryan Wells

All, Im looking for a script to Disable and enable constraints.  Is
there an order?  I would think the PK would need to be enabled first
then the FK.

Answer:

Yes, you should first disable the FK constraints before the PK or Unique
constraints, and enable them in the reverse order.
Disabling is easy (see an example script below.)

When you re-enable a primary key or unique constraint do you want to
recreate the enforcing index with the same storage parameters as it had
before you disabled the constraint? That is a little trickier.

Disabling constraints in a certain order:
define schema = "SPC_TBL_OWNER"
set linesize 132
set pagesize 0
set recsep off
column sort_id1 noprint
column sort_id2 noprint
column sort_id3 noprint
column sort_id4 noprint
 select
    1 as sort_id1,
    owner as sort_id2,
    table_name as sort_id3,
    constraint_name as sort_id4,
    'alter table "' || owner || '"."' || table_name ||
       '"' || chr (10) || '   disable constraint "' || constraint_name
|| '" ;'
       as sql_text
  from all_constraints
  where
     (owner = '&schema' or r_owner = '&schema')
     and constraint_type = 'R'
union all
 select
    2 as sort_id1,
    owner as sort_id2,
    table_name as sort_id3,
    constraint_name as sort_id4,
    'alter table "' || owner || '"."' || table_name ||
       '"' || chr (10) || '   disable constraint "' || constraint_name
|| '" ;'
       as sql_text
  from all_constraints
  where
     owner = '&schema'
     and constraint_type = 'C'
union all
 select
    3 as sort_id1,
    owner as sort_id2,
    table_name as sort_id3,
    constraint_name as sort_id4,
    'alter table "' || owner || '"."' || table_name ||
       '"' || chr (10) || '   disable constraint "' || constraint_name
|| '" ;'
       as sql_text
  from all_constraints
  where
     owner = '&schema'
     and constraint_type in ('P', 'U')
order by
  1, 2, 3, 4 ;






--
http://www.freelists.org/webpage/oracle-l

